#include "DatWindow.hxx"
#include "ui_DatWindow.h"

// --- constructors and deconstructors ---

DatWindow::DatWindow(QWidget *parent)
: QMainWindow(parent), _ui(new Ui::DatWindow), _num(0)
{
    _ui->setupUi(this);

    setupActions();
    setMode(Mode::Fresh);
}

DatWindow::~DatWindow()
{
    delete _ui;
}

// --- public slots ---

void DatWindow::slotDatSave()
{
    //_entry.setOData(_ui->wid_hex->hexData());
    //_entry.setOSize(_ui->wid_hex->HexData.size());
    //_entry.setCSize(_entry.cData().size());
    //_entry.setName(_ui->ed_name->text());
    //_entry.setNameLength(_entry.name().size() + 1);
    //_entry.setHSize(_entry.headerSize() + _entry.nameLength());

    emit sigDatUpdate(_entry, _num);

    setMode(Mode::Fresh);
}

void DatWindow::slotDatDiscard()
{
    _entry = NCFile();
    _num = 0;
    //_ui->wid_hex->clear();

    emit sigDatIgnored();

    setMode(Mode::Fresh);
}

void DatWindow::slotDatView(NCFile& entry, quint32 row)
{
    _entry = entry;
    _num = row;

    _ui->ed_name->setText(_entry.name());
    _ui->wid_hex->setHexData(_entry.oData());
    _ui->ed_size->setText(QString::number(_ui->wid_hex->hexData().size()));
}

// --- protected methods ---

void DatWindow::changeEvent(QEvent *event)
{
    if (event->type() == QEvent::LanguageChange)
        _ui->retranslateUi(this);
    else
        QMainWindow::changeEvent(event);
}

void DatWindow::setMode(const Mode mode)
{
    switch (mode)
    {
        case Mode::Edited:
            _ui->act_dat_save->setEnabled(true);

            break;
        case Mode::Fresh:
        default:
            _ui->act_dat_save->setEnabled(false);
    }
}

void DatWindow::setupActions()
{
    connect(_ui->act_dat_save, SIGNAL(triggered()),
            this, SLOT(slotDatSave()));
    connect(_ui->act_dat_cancel, SIGNAL(triggered()),
            this, SLOT(slotDatDiscard()));
}
