#pragma once

#include <QSyntaxHighlighter>

class FxSyntax : public QSyntaxHighlighter {
    Q_OBJECT
public:
    explicit FxSyntax(QObject *parent = 0);
    explicit FxSyntax(QTextDocument *parent = 0);
    virtual ~FxSyntax();

protected:
    virtual void highlightBlock(const QString& text) override;
    void setup();

private:
    QTextCharFormat _structs_f;
    QTextCharFormat _functions_f;
    QTextCharFormat _ints_f;
    QTextCharFormat _floats_f;
    QTextCharFormat _strings_f;
    QTextCharFormat _comment_f;
    QRegExp _structs_re;
    QRegExp _functions_re;
    QRegExp _ints_re;
    QRegExp _floats_re;
    QRegExp _strings_re;
    QRegExp _comment_re;
};
