#pragma once

#include <QMainWindow>
#include "filesystem/NCFile.hxx"

namespace Ui
{
    class ImageWindow;
}

class ImageWindow : public QMainWindow {
    Q_OBJECT
signals:
    void sigImageUpdate(NCFile& entry, quint32 row) const;
    void sigImageIgnored() const;

public:
    // internal typdefs
    enum class Mode : quint8 {
        Fresh,
        Edited
    };

    // constructors and deconstructors
    explicit ImageWindow(QWidget *parent = 0);
    virtual ~ImageWindow();

public slots:
    void slotImageSave();
    void slotImageDiscard();

    void slotImageView(NCFile& entry, quint32 row);

protected:
    // well well, you know, the protected stuff ... it's always the same
    virtual void changeEvent(QEvent *event);
    void setMode(const Mode mode = Mode::Fresh);
    void setupActions();

private:
    Ui::ImageWindow *_ui;
    NCFile _entry;
    quint32 _num;
};
