#pragma once

#include <QGLWidget>

class GLWidget : public QGLWidget {
    Q_OBJECT
signals:
    void sigClicked() const;

public:
    explicit GLWidget(QWidget *parent = 0, QGLWidget *shared = 0);
    virtual ~GLWidget();

public slots:
    void slotRotateDelta(qreal angle_x, qreal angle_y, qreal angle_z);

protected:
    virtual void initializeGL() override;
    virtual void paintGL() override;
    virtual void resizeGL(qint32 width, qint32 height) override;

    virtual void mousePressEvent(QMouseEvent *event) override;
    virtual void mouseMoveEvent(QMouseEvent *event) override;
    virtual void mouseReleaseEvent(QMouseEvent *event) override;

private:
    QPoint _last_pos;
    qreal _rot_x;
    qreal _rot_y;
    qreal _rot_z;
    QVector<QVector3D> _vertices;
};
