#include <QFile>
#include <QTextStream>
#include "filesystem/NCFile.hxx"

QTextStream out(stdout);
QTextStream err(stderr);

int main(int argc, char **argv)
{
    QFile ifile;
    NCFile entry;
    QString filename = argv[0];
    QByteArray stream;

    if (argc == 2)
        filename = argv[1];

    ifile.setFileName(filename);

    if (!ifile.exists())
    {
        err << "ERROR: unable to open file '" << filename << "'" << endl;
        return 1;
    }

    if (ifile.open(QIODevice::ReadOnly))
    {
        stream.resize(ifile.size());
        ifile.read(stream.data(), ifile.size());
        ifile.close();
    }

    entry.setPosition(17);
    entry.setOSize(stream.size());
    entry.setName(filename);
    entry.setNameLength(filename.size() + 1);
    entry.setOData(stream);
    entry.setCSize(entry.cData().size());
    entry.setHSize(entry.headerSize() + entry.nameLength());

    out << "file: i:" << entry.hSize() << " p:" << entry.position() << " c:" << entry.cSize() << " :o"
        << entry.oSize() << " l:" << entry.nameLength() << " n:'" << entry.name() << "' -> " << entry.size()
        << " bytes" << endl;

    return 0;
}
