#include <QFile>
#include <QTextStream>

QTextStream out(stdout);
QTextStream err(stderr);

struct Furniture {
    float coord[3];
    float rot[3];
    float scale;
    quint32 unk1;
    quint16 mid;
    quint32 unk2[2];
    quint16 unk3;
    quint16 wid;
    quint16 unk4;
    qint32 oid;
    float lower[3];
    float upper[3];
} __attribute__((packed));

int main(int argc, char **argv)
{
    QFile ifile;

    if (argc == 2)
    {
        ifile.setFileName(argv[1]);
        if (ifile.open(QIODevice::ReadOnly))
        {
            QByteArray head;

            while (!ifile.atEnd())
            {
                QByteArray head(5 * 4, '\0');
                quint32 counter = 0;
                quint32 type = 0;
                quint32 size = 0;

                ifile.read(reinterpret_cast<char *>(head.data()), head.size());
                ifile.read(reinterpret_cast<char *>(&type), sizeof (type));
                ifile.read(reinterpret_cast<char *>(&size), sizeof (size));

                out << "head: 0x" << head.toHex().toUpper() << endl
                    << "type: " << type << endl
                    << "size: " << size << endl;

                while (size)
                {
                    QByteArray id(2 * 4, '\0');
                    quint32 objtype = 0;
                    quint32 objsize = 0;

                    ifile.read(reinterpret_cast<char *>(id.data()), id.size());
                    ifile.read(reinterpret_cast<char *>(&objtype), sizeof (objtype));
                    ifile.read(reinterpret_cast<char *>(&objsize), sizeof (objsize));

                    size -= (16 + objsize);

                    out << "---------------------------------------------------" << endl
                        << "index:    " << counter << endl
                        << "id:       0x" << id.toHex().toUpper() << endl
                        << "objtype:  " << objtype << endl
                        << "objsize:  " << objsize << endl
                        << "leftsize: " << size << endl;

                    switch (objtype)
                    {
                        case 1000003:
                        {
                            Furniture f;

                            ifile.read(reinterpret_cast<char *>(&f), sizeof (f));

                            out << "furniture!" << endl
                                << "pos:      " << f.coord[0] << ", " << f.coord[1] << ", " << f.coord[2] << endl
                                << "rot:      " << f.rot[0] << ", " << f.rot[1] << ", " << f.rot[2] << endl
                                << "scale:    " << f.scale << endl
                                << "unk1:     " << f.unk1 << endl
                                << "model id: " << f.mid << endl
                                << "unk2:     " << f.unk2[0] << ", " << f.unk2[1] << endl
                                << "unk3:     " << f.unk3 << endl
                                << "world id: " << f.wid << endl
                                << "unk4:     " << f.unk4 << endl
                                << "obj id:   " << f.oid << endl
                                << "low box:  " << f.lower[0] << ", " << f.lower[1] << ", " << f.lower[2] << endl
                                << "up box:   " << f.upper[0] << ", " << f.upper[1] << ", " << f.upper[2] << endl;

                            break;
                        }
                        default:
                            ifile.seek(ifile.pos() + objsize);
                    }
                    ++counter;
                }
            }
            ifile.close();
        }

        return 0;
    }

    out << "usage: " << argv[0] << " <dat file>" << endl;

    return 0;
}
